VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CasTarifu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"CasyTarifu"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mvarCasyTarifu As CasyTarifu
Public Den As TDen
Public Datum As Date
Public CasOd As Date
Public CasDo As Date
Public Pocet As Byte
Private Impulzy(0 To 9) As TImpulz

Public Sub AssignImpulzyStr(ByVal Str As String)
  Call StrToImpulzy(Str, Pocet, Impulzy)
End Sub

' vrati delka n-teho impulzu v casovem intervalu
Public Function DelkaImpulzu(ByVal Poradi As Integer) As Long
  Dim I As Integer
  Dim R As Long
  
  ' projizdime impulzy poporadi a hledame ten nas
  Do While (I < Pocet) And (Poradi > Impulzy(I).Kolikrat)
    Poradi = Poradi - Impulzy(I).Kolikrat
    I = I + 1
  Loop
  If I < Pocet Then
    ' pokud jsme ho nasli vratime jeho delku
    R = Impulzy(I).Delka
  ElseIf Pocet > 0 Then
    ' pokud jsme prejeli pres konec tak vratime delku posledniho
    R = Impulzy(Pocet - 1).Delka
  Else
    'jinak vratime minutu
    R = 60
  End If
  DelkaImpulzu = R
End Function

' vrati retezec s rozlozenim impulzu
Public Function ImpulseStr() As String
  ImpulseStr = ImpulzyToStr(Pocet, Impulzy)
End Function

' vrati casovy rozsah
Public Function TimeStr() As String
  TimeStr = ImpulzyTimeStr(CasOd) & " - " & ImpulzyTimeStr(CasDo)
End Function

' vrati identifikaci dne
Public Function DayStr() As String
  If Den <> dnKonkretni Then
    DayStr = DenStrCz(Den)
  Else
    DayStr = DatePart("d", Datum) & "." & DatePart("m", Datum) & "."
  End If
End Function

' priradi atributy podle jineho casove intervalu (klonovani)
Public Sub Assign(ByVal CasTarifu As CasTarifu)
  Den = CasTarifu.Den
  Datum = CasTarifu.Datum
  CasOd = CasTarifu.CasOd
  CasDo = CasTarifu.CasDo
  Call StrToImpulzy(CasTarifu.ImpulseStr, Pocet, Impulzy)
End Sub

' nastyavy atributy podle dat nahranych z databaze
Public Sub AssignRecord(ByVal RKdy As Variant, ByVal RDen As Variant, ByVal RCasOd As Variant, _
    ByVal RCasDo As Variant, ByVal RImpulzy As Variant)
  Dim S As String, DenS As String
  Dim DenD As TDen
  Dim DenN As Byte, MesicN As Byte, HodN As Byte, MinN As Byte
  
  DenS = UCase(RKdy)
  ' vyhleda o ktery den jde podle jeho nazvu
  For DenD = dnKonkretni To dnSvatek
    If DenS = UCase(DenStr(DenD)) Then Exit For
    If DenD = dnSvatek Then Exit Sub
  Next
  Den = DenD
  If Den = dnKonkretni Then
    ' pokud jde o konkretni den ulozime i datum
    Datum = NaImplicitniRok(RDen)
  Else
    ' jinak to nema vyznam
    Datum = 0
  End If
  ' casovy rozsah
  CasOd = TimeValue(RCasOd)
  CasDo = TimeValue(RCasDo)
  If CasDo = 0 Then CasDo = 1
  ' prevedeme retezec na pole impulzu
  Call StrToImpulzy(RImpulzy, Pocet, Impulzy)
End Sub

' nastavime impicitni hodnoty
Private Sub Class_Initialize()
  Den = dnKazdy
  Datum = 0
  CasOd = 0
  CasDo = 1
  Pocet = 0
End Sub

' ------------- vygenerovane metody ---------------
Public Property Get CasyTarifu() As CasyTarifu
  If mvarCasyTarifu Is Nothing Then
    Set mvarCasyTarifu = New CasyTarifu
  End If
  
  Set CasyTarifu = mvarCasyTarifu
End Property

Public Property Set CasyTarifu(vData As CasyTarifu)
    Set mvarCasyTarifu = vData
End Property

Private Sub Class_Terminate()
  Set mvarCasyTarifu = Nothing
End Sub
