VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CasyTarifu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"CasTarifu"
Attribute VB_Ext_KEY = "Member0" ,"CasTarifu"
Option Explicit

'local variable to hold collection
Private mCol As Collection

' projede vsechny casy urciteho typu a zjisti jestli odpovidaji
' zadani predanemu jako parametr
Function SrovnavejCasy(ByVal Identifikuj As Integer, ByVal Datum As Date, _
    ByVal Cas As Date, ByVal DoW As Byte) As CasTarifu
  Dim I As Integer
  Dim B As Boolean
  Dim C As CasTarifu
  
  For I = 1 To Count
    Set C = Item(I)
    Select Case Identifikuj
        ' pokud hledame konkretni datum porovname data
      Case 0: B = (C.Den = dnKonkretni) And (C.Datum = Datum)
        ' pokud hledame svatek zjistime jestli je to svatek
      Case 1: B = (C.Den = dnSvatek) And JeToSvatek(Svatky, Datum)
        ' pokdu hledame den v tydnu zjistime jestli je stejny
      Case 2: B = (C.Den >= dnPondeli) And (C.Den < dnNedele) And (DenDoW(DoW) = C.Den)
        ' pokud hedame vsedni den/vikend zjistime jestli den v tydnu odpovida
      Case 3: B = ((C.Den = dnVsedni) And (DoW >= 2) And (DoW <= 6)) Or _
                  ((C.Den = dnVikend) And ((DoW = 1) Or (DoW = 7)))
        ' kdyz uz je to jedno (jakykoliv den)
      Case 4: B = (C.Den = dnKazdy)
    End Select
    ' pokd jsme nasli den overime jeste cas
    If B And (Cas >= C.CasOd) And (Cas < C.CasDo) Then
      ' pokud i cas vyhovuje mame vyhrano
      Set SrovnavejCasy = C
      Exit Function
    End If
  Next
  ' pokud to doslo az sem neasli jsme nic
  Set SrovnavejCasy = Nothing
End Function

' vyhleda casovy interval odpovidajici predanemu okamziku
Public Function NajdiCas(ByVal Kdy As Date) As CasTarifu
  Dim Datum As Date, Cas As Date
  Dim DoW, I As Byte
  Dim C As Variant
  
  Datum = NaImplicitniRok(Kdy)
  Cas = TimeValue(Kdy)
  DoW = Weekday(Kdy)
  
  ' vyhledavame v poradi techto kategorii:
  ' 0 - konkretni den
  ' 1 - statni svatek
  ' 2 - den v tydnu
  ' 3 - jakykoliv vsedni den/svatek
  ' 4 - jakykoliv den
  Set C = Nothing: I = 1
  Do
    Set C = SrovnavejCasy(I, Datum, Cas, DoW)
    I = I + 1
  Loop While (C Is Nothing) And (I <= 4)
  Set NajdiCas = C
End Function

' klonovani (vytvori identicky seznam casu)
Public Sub Assign(ByVal CasyTarifu As CasyTarifu)
  Dim I As Integer
  Dim Cas As CasTarifu
  
  ' pro kazdy prvek kopirovaneho seznamu ...
  For I = 1 To CasyTarifu.Count
    ' ... vytvorime novy objekt ...
    Set Cas = Add(Me)
    ' ... a prekopirujeme jeho parametry
    Call Cas.Assign(CasyTarifu.Item(I))
  Next
End Sub

' ------------- vygenerovane metody --------------------

Public Function Add(CasyTarifu As CasyTarifu, Optional sKey As String) As CasTarifu
    'create a new object
    Dim objNewMember As CasTarifu
    Set objNewMember = New CasTarifu


    'set the properties passed into the method
    Set objNewMember.CasyTarifu = CasyTarifu
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As CasTarifu
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

